import e, { createContext as K, useContext as Q, useMemo as M, useCallback as V, useRef as L, useEffect as B, useState as A } from "react";
import { get as T, set as Y, clone as $ } from "radash";
import { usePointerDrag as X } from "react-use-pointer-drag";
import { SketchPicker as Z } from "react-color";
import _ from "filesize";
const U = K(void 0);
function C(a, l, o) {
  const n = Q(U), t = M(() => (n == null ? void 0 : n.getValue(a)) ?? l, [n, a, l]), c = V((r) => {
    a && n && n.setValue(a, r), o == null || o(r);
  }, [a, n, o]);
  return [t, c];
}
const ce = ({ values: a, updateValues: l, onChange: o, onChangeValue: n, className: t, children: c }) => {
  const r = V((u) => u ? T(a, u) : void 0, [a]), s = V((u, m) => {
    n == null || n(u, m);
    const v = Y($(a), u, m);
    l == null || l(v), o == null || o(v);
  }, [a, l, o, n]), i = M(() => ({ values: a, getValue: r, setValue: s }), [a, r, s]);
  return e.createElement(
    U.Provider,
    { value: i },
    e.createElement("div", { className: "react-var-ui " + (t ?? "") }, c)
  );
}, b = ({ label: a, children: l, className: o, disabled: n, readOnly: t, column: c = !1 }) => e.createElement(
  "div",
  { className: "react-var-ui-label " + (a ? "react-var-ui-label-has-label " : "react-var-ui-label-no-label ") + (n ? "react-var-ui-disabled " : "") + (t ? "react-var-ui-read-only " : "") + (c ? "react-var-ui-label-column " : "") + (o ?? "") },
  !!a && e.createElement("span", null, a),
  l
), z = Math.PI * 2;
function D(a) {
  return (z + a % z) % z;
}
const ne = ({ label: a, path: l, value: o, onChange: n, disabled: t, readOnly: c, defaultValue: r = 0, className: s }) => {
  const i = L(null), [u, m] = C(l, o, n), v = M(() => Math.round(D(u) * (180 / Math.PI)), [u]), { dragProps: g } = X({
    onMove: ({ x: d, y: E }) => {
      if (!i.current)
        return;
      const f = i.current.getBoundingClientRect(), N = f.left + f.width / 2, h = f.top + f.height / 2;
      m(D(Math.atan2(E - h, d - N) + Math.PI / 2));
    }
  });
  return B(() => {
    var d;
    (d = i.current) == null || d.addEventListener("wheel", (E) => E.preventDefault());
  }, []), e.createElement(
    b,
    { label: a, disabled: t, readOnly: c, className: s, column: !0 },
    e.createElement(
      "span",
      { className: "react-var-ui-angle-value" },
      v,
      "°"
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-angle" },
      e.createElement("div", { className: "react-var-ui-angle-control react-var-ui-interactive", ref: i, style: { transform: `rotate(${v}deg)` }, onDoubleClick: () => typeof r < "u" && m(r), onWheel: (d) => {
        m(D(u + 0.5 * (d.deltaY < 0 ? -1 : 1)));
      }, title: "Angle", ...g() })
    )
  );
}, le = ({ path: a, value: l, onChange: o, disabled: n, className: t, children: c }) => {
  const [r, s] = C(a, l, o);
  return e.createElement("div", { className: "react-var-ui-array " + (n ? "react-var-ui-disabled " : "") + (t ?? "") }, r == null ? void 0 : r.map((i, u, m) => e.createElement(U.Provider, { value: {
    values: i,
    getValue: (v) => v ? T(i, v) : void 0,
    setValue: (v, g) => {
      const d = [...r];
      d[u] = Y($(i), v, g), s(d);
    }
  }, key: u }, typeof c == "function" ? c(i, u, m) : c)));
}, oe = ({ label: a, onClick: l, buttonLabel: o, disabled: n, className: t }) => e.createElement(
  b,
  { label: a, disabled: n, className: t },
  e.createElement(
    "span",
    { className: "react-var-ui-button" },
    e.createElement("button", { onClick: () => l == null ? void 0 : l(), disabled: n }, o)
  )
), se = ({ label: a, path: l, value: o, onChange: n, alpha: t, disabled: c, readOnly: r, className: s }) => {
  const [i, u] = C(l, o, n), [m, v] = A(!1), g = V(() => v((E) => !E), [v]), d = V(() => v(!1), [v]);
  return e.createElement(
    b,
    { label: a, disabled: c, readOnly: r, className: s },
    e.createElement(
      "span",
      null,
      e.createElement("span", { className: "react-var-ui-color-value" }, i),
      e.createElement(
        "div",
        { className: "react-var-ui-color react-var-ui-interactive" },
        e.createElement(
          "div",
          { className: "react-var-ui-color-swatch", onClick: g },
          e.createElement("div", { className: "react-var-ui-color-color", title: "Color preview", style: { background: i } })
        ),
        m ? e.createElement(
          "div",
          { className: "react-var-ui-color-popover" },
          e.createElement("div", { className: "react-var-ui-color-cover", onClick: d }),
          e.createElement(Z, { color: i, onChange: (E) => {
            const p = E.hex === "transparent" ? "#000000" : E.hex;
            if (t) {
              let f = Math.round((E.rgb.a ?? 1) * 255).toString(16);
              f.length === 1 && (f = "0" + f), u(p + f);
            } else
              u(p);
          }, disableAlpha: !t })
        ) : null
      )
    )
  );
}, ie = ({ label: a, path: l, value: o, disabled: n, readOnly: t, className: c }) => {
  const [r] = C(l, o);
  return e.createElement(
    b,
    { label: a, disabled: n, readOnly: t, className: c },
    e.createElement("span", null, r)
  );
}, j = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { d: "M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z" }),
  e.createElement("path", { d: "M7.646 1.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 2.707V11.5a.5.5 0 0 1-1 0V2.707L5.354 4.854a.5.5 0 1 1-.708-.708l3-3z" })
), ue = ({ label: a, path: l, value: o, onChange: n, disabled: t, readOnly: c, className: r, accept: s, displayMetadata: i = !0 }) => {
  const [u, m] = C(l, o, n), v = V((g) => {
    var E;
    if (!((E = g.target.files) != null && E.length))
      return;
    const d = g.target.files[0];
    m(d);
  }, [m]);
  return e.createElement(
    b,
    { label: a, disabled: t, readOnly: c, className: r },
    e.createElement("span", { className: "react-var-ui-file-value" }, u == null ? void 0 : u.name),
    e.createElement(
      "div",
      { className: "react-var-ui-file react-var-ui-interactive" },
      i && !!u && e.createElement(
        "div",
        { className: "react-var-ui-file-metadata" },
        e.createElement(
          "div",
          null,
          "Size: ",
          _(u.size)
        ),
        e.createElement(
          "div",
          null,
          "Type: ",
          u.type || "unknown"
        )
      ),
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: s, onChange: v, title: "File upload" })
    )
  );
}, ve = ({ label: a, path: l, value: o, onChange: n, disabled: t, readOnly: c, className: r }) => {
  const [s, i] = C(l, o, n), u = V((m) => {
    var d;
    if (!((d = m.target.files) != null && d.length))
      return;
    const v = m.target.files[0], g = URL.createObjectURL(v);
    i(g);
  }, [i]);
  return e.createElement(
    b,
    { label: a, disabled: t, readOnly: c, className: r, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-image react-var-ui-interactive" },
      e.createElement("div", { className: "react-var-ui-image-background", style: {
        backgroundImage: s ? `url('${s}')` : void 0
      }, title: "Image preview" }),
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: "image/*", onChange: u, title: "Image upload" })
    )
  );
}, me = ({ label: a, path: l, value: o, onChange: n, disabled: t, readOnly: c, className: r, acceptImage: s, acceptAudio: i, acceptVideo: u }) => {
  const [m, v] = C(l, o, n), [g, d] = A(), E = M(() => {
    let h = "";
    return s && (h += "image/*,"), i && (h += "audio/*,"), u && (h += "video/*,"), h.endsWith(",") && (h = h.slice(0, -1)), h || (h = "image/*,audio/*,video/*"), h;
  }, [s, i, u]), p = V((h) => {
    var I;
    if (!((I = h.target.files) != null && I.length))
      return;
    const w = h.target.files[0], k = URL.createObjectURL(w);
    v(k);
  }, [v, d]), f = V(async (h) => {
    var k, I, S;
    if (!h) {
      d(void 0);
      return;
    }
    const w = await fetch(h);
    d((S = (I = (k = w == null ? void 0 : w.headers) == null ? void 0 : k.get("Content-Type")) == null ? void 0 : I.split("/")) == null ? void 0 : S[0]);
  }, [d]);
  B(() => {
    f(m);
  }, [m]);
  let N = e.createElement("div", { className: "react-var-ui-media-metadata" }, m ? "Unsupported file type." : "");
  switch (g) {
    case "image":
      N = e.createElement("div", { className: "react-var-ui-media-background", style: {
        backgroundImage: `url('${m}')`
      }, title: "Media preview" });
      break;
    case "video":
      N = e.createElement("video", { className: "react-var-ui-media-background", muted: !0, loop: !0, autoPlay: !0, src: m, title: "Media preview" });
      break;
    case "audio":
      N = e.createElement("audio", { className: "react-var-ui-media-audio", loop: !0, controls: !0, src: m, title: "Media preview" });
      break;
  }
  return e.createElement(
    b,
    { label: a, disabled: t, readOnly: c, className: r, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-media react-var-ui-interactive" },
      N,
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: E, onChange: p, title: "Media upload" })
    )
  );
};
function P(a, l, o, n, t) {
  var r;
  isFinite(a) || (a = l ?? 0);
  let c = 2;
  return typeof n == "number" && (c = ((r = n.toString().split(".")[1]) == null ? void 0 : r.length) || 0, c > 20 && (c = 20), a = Math.round(a / n) * n), typeof l == "number" && (a = Math.max(l, a)), typeof o == "number" && (a = Math.min(o, a)), t ? Math.round(a) : parseFloat(a.toFixed(c));
}
const J = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z" })
), W = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M7.646 4.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1-.708.708L8 5.707l-5.646 5.647a.5.5 0 0 1-.708-.708l6-6z" })
), de = ({ label: a, path: l, value: o, onChange: n, min: t, max: c, step: r = 1, integer: s, showButtons: i, disabled: u, readOnly: m, className: v }) => {
  const [g, d] = C(l, o, n), E = M(() => P(g, t, c, r, !!s), [g, t, c, r, s]), p = V(() => d(P(g + (r ?? 1), t, c, r, !!s)), [g, d, s, t, c, r]), f = V(() => d(P(g - (r ?? 1), t, c, r, !!s)), [g, d, s, t, c, r]);
  return e.createElement(
    b,
    { label: a, disabled: u, readOnly: m, className: v },
    e.createElement(
      "div",
      { className: "react-var-ui-number" },
      e.createElement("input", { className: "react-var-ui-number-input", type: "number", min: t, max: c, step: r, value: E.toString(), disabled: u, readOnly: m, onChange: (N) => d(P(parseFloat(N.target.value), t, c, r, !!s)) }),
      i && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: p, disabled: u || m },
          e.createElement(W, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: f, disabled: u || m },
          e.createElement(J, null)
        )
      )
    )
  );
}, Ee = ({ path: a, value: l, onChange: o, children: n }) => {
  const [t, c] = C(a, l, o);
  return e.createElement(U.Provider, { value: {
    values: t,
    getValue: (r) => r ? T(t, r) : void 0,
    setValue: (r, s) => {
      const i = Y($(t), r, s);
      c(i);
    }
  } }, n);
}, ge = ({ label: a, path: l, value: o, onChange: n, options: t, disabled: c, readOnly: r, className: s }) => {
  const [i, u] = C(l, o, n), m = M(() => JSON.stringify(i), [i]);
  return e.createElement(
    b,
    { label: a, disabled: c, readOnly: r, className: s },
    e.createElement(
      "div",
      { className: "react-var-ui-select" },
      e.createElement("select", { onChange: (v) => u(JSON.parse(v.target.value)), value: m, title: "Select options", disabled: c || r }, t.map((v) => {
        const g = JSON.stringify(v.value ?? v.key);
        return e.createElement("option", { key: v.key, value: g }, v.label);
      }))
    )
  );
}, fe = ({ label: a, path: l, value: o, onChange: n, min: t, max: c, step: r, integer: s, defaultValue: i, showInput: u, showButtons: m, disabled: v, readOnly: g, className: d }) => {
  const E = L(null), [p, f] = C(l, o, n), N = M(() => P(p, t, c, r, !!s), [p, t, c, r, s]), h = M(() => (N - t) / (c - t) * 100, [N, t, c]), w = V((y) => {
    if (!E.current)
      return;
    const R = E.current.getBoundingClientRect(), q = (y - R.left) / R.width, G = P(t + (c - t) * q, t, c, r, !!s);
    f(G);
  }, [f, s, t, c, r]), k = V(() => f(P(p + r, t, c, r, !!s)), [p, f, s, t, c, r]), I = V(() => f(P(p - r, t, c, r, !!s)), [p, f, s, t, c, r]), { dragProps: S } = X({
    onMove: ({ x: y }) => w(y)
  });
  return B(() => {
    var y;
    (y = E.current) == null || y.addEventListener("wheel", (F) => F.preventDefault());
  }, []), e.createElement(
    b,
    { label: a, disabled: v, readOnly: g, className: d },
    e.createElement(
      "div",
      { className: "react-var-ui-slider" },
      e.createElement(
        "div",
        { className: "react-var-ui-slider-track react-var-ui-interactive", ref: E, onClick: (y) => w(y.clientX), onDoubleClick: () => typeof i < "u" && f(i), onWheel: (y) => {
          y.deltaY < 0 ? k() : I();
        }, title: "Slider", ...S() },
        e.createElement("div", { className: "react-var-ui-slider-content", style: { width: h + "%" } })
      ),
      u ? e.createElement("input", { className: "react-var-ui-slider-input", type: "number", min: t, max: c, step: r, value: N, disabled: v, readOnly: g, onChange: (y) => f(P(parseFloat(y.target.value), t, c, r, !!s)) }) : e.createElement("span", null, N.toString()),
      m && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: k, disabled: v || g },
          e.createElement(W, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: I, disabled: v || g },
          e.createElement(J, null)
        )
      )
    )
  );
}, pe = ({ label: a, path: l, value: o, onChange: n, maxLength: t, multiline: c, autoexpand: r, disabled: s, readOnly: i, className: u }) => {
  const [m, v] = C(l, o, n), g = (E) => {
    const p = E.currentTarget;
    p.style.height = "0", p.style.height = `${p.scrollHeight}px`;
  }, d = M(() => r ? { overflow: "hidden", resize: "none" } : void 0, [r]);
  return e.createElement(b, { label: a, disabled: s, readOnly: i, className: u, column: c }, c ? e.createElement("textarea", { className: "react-var-ui-string-multiline", value: m, onChange: (E) => v(E.target.value), onInput: r ? g : void 0, style: d, disabled: s, readOnly: i }) : e.createElement(
    "span",
    { className: "react-var-ui-string" },
    e.createElement("input", { type: "text", maxLength: t, value: m, onChange: (E) => v(E.target.value), disabled: s, readOnly: i })
  ));
}, he = ({ label: a, path: l, value: o, onChange: n, disabled: t, readOnly: c, className: r }) => {
  const [s, i] = C(l, o, n);
  return e.createElement(
    b,
    { label: a, disabled: t, readOnly: c, className: r },
    e.createElement(
      "span",
      null,
      e.createElement(
        "label",
        { className: "react-var-ui-toggle", title: "Toggle" },
        e.createElement("input", { type: "checkbox", checked: s, onChange: (u) => i(u.target.checked), disabled: t, readOnly: c }),
        e.createElement("span", { className: "react-var-ui-toggle-helper" })
      )
    )
  );
};
function H(a, l, o, n) {
  var c;
  const t = [0, 0];
  if (!a || !Array.isArray(a) || a.length < 2)
    return t;
  for (let r = 0; r < n.length; r++) {
    const s = ((c = n[r].toString().split(".")[1]) == null ? void 0 : c.length) || 0;
    t[r] = Math.round(a[r] / n[r]) * n[r], t[r] = Math.max(l[r], t[r]), t[r] = Math.min(o[r], t[r]), t[r] = parseFloat(t[r].toFixed(s));
  }
  return t;
}
function x(a, l, o) {
  if (!a)
    return [50, 50];
  const n = [0, 0];
  for (let t = 0; t < a.length; t++)
    n[t] = (a[t] - l[t]) / (o[t] - l[t]) * 100;
  return n;
}
const Ve = ({ label: a, path: l, value: o, onChange: n, disabled: t, readOnly: c, className: r, defaultValue: s = [0, 0], min: i = [-1, -1], max: u = [1, 1], step: m = [0.01, 0.01] }) => {
  const v = L(null), [g, d] = C(l, o, n), E = M(() => H(g, i, u, m), [g, i, u, m]), p = M(() => x(E, i, u), [E, i, u]), f = V((w, k) => {
    if (!v.current)
      return;
    const S = v.current.getBoundingClientRect(), y = (w - S.left) / S.width, F = (k - S.top) / S.height, R = H([
      i[0] + (u[0] - i[0]) * y,
      i[1] + (u[1] - i[1]) * F
    ], i, u, m);
    d(R);
  }, [d, i, u, m]), { dragProps: N } = X({
    onMove: ({ x: w, y: k }) => f(w, k)
  }), h = V(() => {
    typeof s < "u" && d(s);
  }, [s, d]);
  return e.createElement(
    b,
    { label: a, disabled: t, readOnly: c, className: r, column: !0 },
    e.createElement(
      "span",
      { className: "react-var-ui-xy-value" },
      E[0],
      ", ",
      E[1]
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-xy react-var-ui-interactive" },
      e.createElement(
        "div",
        { className: "react-var-ui-xy-space", ref: v, onClick: (w) => f(w.clientX, w.clientY), onDoubleClick: h, ...N() },
        e.createElement("div", { className: "react-var-ui-xy-control", style: { top: p[1] + "%", left: p[0] + "%" } })
      )
    )
  );
}, Ne = ({ label: a, className: l, children: o, collapsible: n }) => {
  const [t, c] = A(!1);
  return e.createElement(
    "div",
    { className: "react-var-ui-category " + (l ?? "") },
    e.createElement(
      "div",
      { className: "react-var-ui-category-title" },
      a,
      n && e.createElement("button", { title: t ? "Expand" : "Collapse", className: "react-var-ui-category-collapse", onClick: () => c((r) => !r) }, t ? e.createElement(J, null) : e.createElement(W, null))
    ),
    (!n || !t) && e.createElement("div", null, o)
  );
};
export {
  ne as VarAngle,
  le as VarArray,
  b as VarBase,
  oe as VarButton,
  Ne as VarCategory,
  se as VarColor,
  ie as VarDisplay,
  ue as VarFile,
  ve as VarImage,
  me as VarMedia,
  de as VarNumber,
  Ee as VarScope,
  ge as VarSelect,
  fe as VarSlider,
  pe as VarString,
  he as VarToggle,
  ce as VarUI,
  Ve as VarXY,
  C as useVarUIValue
};
